# Bison

Bison's webpage is at <https://www.gnu.org/software/bison/>.
Installing it should be as easy as installing flex, please let me know if you are facing issues.

# Calc Example

The calc example is very famous and multiple variations of it exist.
I have based this one on <https://github.com/schnorr/calc>.

To compile it, simply run `make` in the calc folder, or open up the Makefile file to read the commands used. It produces a few warnings on compilation, but nothing to worry about.

The example was discussed in class and there is nothing I can think of to add about it.
I recommend running `bison -v calc.y` to produce the `calc.output` file and to inspect it.

# Conflict

This example is inspired from <https://stackoverflow.com/questions/17590190/shift-reduce-conflicts-in-bison>.
Use `bison conflict.y` to see the warning issued, and `bison -v conflict.y` to produce a `conflict.output` file describing the automata generated.

The $default rules _does not_ means that this is the "defaut" action. Cf. e.g.

    Something  shift, and go to state 1

    Something  [reduce using rule 4 (Record)]
    $default   reduce using rule 4 (Record)

This means that shift is applied first (as it should in a shift - reduce conflict, cf. <https://www.gnu.org/software/bison/manual/html_node/Shift_002fReduce.html>), as it is higher.
The $default part is actually expressing the fact that if more tokens are needed to determine which rule to apply, then this one should be applied. You can read about it at <https://www.gnu.org/software/bison/manual/html_node/Default-Reductions.html>:

> After parser table construction, Bison identifies the reduction with the largest lookahead set in each parser state. To reduce the size of the parser state, traditional Bison behavior is to remove that lookahead set and to assign that reduction to be the default parser action. Such a reduction is known as a default reduction. 


# Additional ressources

- <https://www.eecg.utoronto.ca/~jzhu/csc467/readings/csc467-bison-tut.pdf> contains some basic information about bison and is probably a good place to start.
- <https://www.usna.edu/Users/cs/lmcdowel/courses/si413/F10/labs/L04/calc1/ex1.html> is a simpler calculator project, useful if you want to test your understanind of the previous one. However, it is written in C++.
- <http://ianfinlayson.net/class/cpsc401/notes/08-bison> is a (somewhat lenghty) very good introduction to bison and its interactions with flex.
- I have intensively used _Flex & Bison_ by John Levine, and it is an excellent ressource to go more in depth on this topic.


C. Aubert, https://spots.augusta.edu/caubert/cw/, Fall 2021.
